/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.76
        Device            :  PIC16F18326
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include <stdio.h>
#include "mcc_generated_files/mcc.h"
#include "lcd_lib2.h"
#include "i2c_lib2.h"
#include "i2c-lib.h"

#define SHT31_ADDR 0x8A         // SHT31  X[uAhX`:0b1000101(0x45)+0 = 0b10001010 = 0x8A 
#define RTC8564_ADDR 0xA2       // RTC8564X[uAhX`:0b1010001(0x51)+0 = 0b10100010 = 0xA2 
#define SW1 RA3                 // [h؂ւXCb`
#define SW2 RC5                 // Ԑ؂ւXCb`
#define SW3 RC4                 // ύXXCb`
#define Buz RA5                 // uU[o
#define AlarmSW RA4             // A[XCb`

// O[oϐ錾
unsigned long St,Srh;           // xx16bitf[^i[pϐ
unsigned long Temp,Humi;        // Temp:xϐ,Humi:xϐ
unsigned long data[6];          // SHT31WX^Mf[^i[pϐ
unsigned long Sec,Min,Hour;     // b,,
unsigned long AlarmSec,AlarmMin,AlarmHour;     // A[b,A[,A[ 
unsigned int SetFlag;           // ԃZbg؂ւptO
unsigned int State;             // ݒ؂ւtO

// vg^CsO錾
void CurDisp_Alarm_ON(void);     // x/\(A[XCb`ON)֐
void CurDisp_Alarm_OFF(void);    // x/\(A[XCb`OFF)֐
void RTC8564_INIT(void);      // RTC֐
void SHT31(void);              // xZT[֐
void Conv(void);               // xlϊ֐
void Buzzer(void);             // uU[֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);             // t\Wo͊֐Ƃ
}

/*
    Main application
 */

void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    __delay_ms(1000);           // UqUJn҂:1sec(RTCO)    

    // foCX
    RTC8564_INIT();             // RTC(荞݋O)    
    lcd_init();                 // LCD                

    // ϐ    
    Sec = 0;
    Min = 0;
    Hour = 0;        
    AlarmSec = 0;
    AlarmMin = 50;
    AlarmHour = 5;
    SetFlag = 0;    
    State = 0xFF;
    
    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code
                                
        if(SetFlag == 0) {              // SetFlag:0(݂̉x/\)  

            if(AlarmSW == 0)            // A[XCb`ONȂ
                CurDisp_Alarm_ON();     // CurDisp_Alarm_ON֐Ăяo

            if(AlarmSW == 1)            // A[XCb`OFFȂ
                CurDisp_Alarm_OFF();    // CurDisp_Alarm_OFF֐Ăяo            
            
            if((Hour == AlarmHour) && (Min == AlarmMin))    // ݎ = A[ݒ莞Ȃ
                Buzzer();               // uU[(1)                    
            
            if(SW1 == 0) {              // ݒ SW1I            
                SetFlag = 1;            // SetFlag -> 1                
                GIE = 0;                // O[o荞݋֎~
                State = 0xFF;           // StateZbg
                while (SW1 == 0)        // `^O        
                __delay_ms(25);                   

                lcd_cmd(0x80);                  // LCD1s
                    printf("Start TimeSet   ");       // bZ[W
                lcd_cmd(0xC0);                  // LCD2s
                    printf("Push SW2        ");       // bZ[W                    
            }        
        }

        else {
            if(SW2 == 0) {                  // I SW2I            
                State++;                    // StateJEgAbv                    

                if (State > 4)              // State > 4Ȃ       
                    State = 0;              // StateZbg                
                while (SW2 == 0)            // `^O        
                __delay_ms(25);                                       
            }
                
            switch(State) {                     // State
                case 0:
                    lcd_cmd(0x80);              // LCD1s
                        printf("Current:Hour? %2lu", Hour);     // ݁uvݒ   
                    lcd_cmd(0xC0);              // LCD2s
                        printf("SW3:Set/SW2:Next");   // bZ[W 

                    if(SW3 == 0) {              // SW3(ݒ)IH            
                        while (SW3 == 0)        // `^O        
                        __delay_ms(25);                        

                        Hour++;                 // HourJEgAbv
                        if (Hour >= 24)         // Hour24Ȃ
                            Hour = 0;           // HourZbg
                    }
                    break;

                case 1:                
                    lcd_cmd(0x80);              // LCD1s
                        printf("Current:Min?  %2lu", Min);     // ݁uvݒ   
                    lcd_cmd(0xC0);              // LCD2s
                        printf("SW3:Set/SW2:Next");   // bZ[W 

                    if(SW3 == 0) {              // SW3(ݒ)IH            
                        while (SW3 == 0)        // `^O        
                        __delay_ms(25);                        

                        Min++;                  // MinJEgAbv
                        if (Min >= 60)          // Min60Ȃ
                            Min = 0;            // MinZbg                        
                    }
                    break;

                case 2:                                 
                    lcd_cmd(0x80);              // LCD1s
                        printf("Alarm:Hour?   %2lu", AlarmHour);     // A[uvݒ   
                    lcd_cmd(0xC0);              // LCD2s
                        printf("SW3:Set/SW2:Next");   // bZ[W 

                    if(SW3 == 0) {              // SW3(A[ݒ)IH            
                        while (SW3 == 0)        // `^O        
                        __delay_ms(25);                        

                        AlarmHour++;            // AlarmHourJEgAbv
                        if (AlarmHour >= 24)    // AlarmHour24Ȃ
                            AlarmHour = 0;      // AlarmHourZbg
                    }                                
                    break;
                        
                case 3:                
                    lcd_cmd(0x80);              // LCD1s
                        printf("Alarm:Min?    %2lu", AlarmMin);     // A[uvݒ
                    lcd_cmd(0xC0);              // LCD2s
                        printf("SW3:Set/SW2:Next");   // bZ[W 

                    if(SW3 == 0) {              // SW3(A[ݒ)IH            
                        while (SW3 == 0)        // `^O        
                        __delay_ms(25);                        

                        AlarmMin++;             // AlarmMinJEgAbv
                        if (AlarmMin >= 60)     // AlarmMin60Ȃ
                            AlarmMin = 0;       // AlarmMinZbg                        
                    }
                    break;                                

                case 4:
                    lcd_cmd(0x80);              // LCD1s
                        printf("End TimeSet     ");   // bZ[W        
                    lcd_cmd(0xC0);              // LCD2s
                        printf("Push SW1        ");   // bZ[W   
                    
                    if(SW1 == 0) {          // SW1(ԃZbg)IH            
                        lcd_clear();        // LCDNA
                        Sec = 0;            // ubvZbg
                        SetFlag = 0;        // SetFlag=0(݂̉x/\)ɐ؂ւ
                        GIE = 1;            // O[o荞݋
                        while (SW1 == 0)    // `^O        
                        __delay_ms(25);                            
                    }
                    break;
                                
                default:break;
            }                                
        }
    }        
}

// x/\(A[XCb`ON)֐
void CurDisp_Alarm_ON(void) {

        lcd_cmd(0x80);      // LCD1s
            printf("%2lu:%2lu:%2lu * %2lu:%2lu", Hour,Min,Sec,AlarmHour,AlarmMin);     // ݎ_A[

        SHT31();            // xZT[֐Ăяo        

        lcd_cmd(0xC0);                      // LCD2s
            printf("%3lu degC %3lu %%RH", Temp,Humi);     // x_xl\

        __delay_ms(100);    // h~              
}

// x/\(A[XCb`OFF)֐
void CurDisp_Alarm_OFF(void) {

        lcd_cmd(0x80);      // LCD1s
            printf("%2lu:%2lu:%2lu   %2lu:%2lu", Hour,Min,Sec,AlarmHour,AlarmMin);     // ݎ_A[

        SHT31();            // xZT[֐Ăяo        

        lcd_cmd(0xC0);                      // LCD2s
            printf("%3lu degC %3lu %%RH", Temp,Humi);     // x_xl\

        __delay_ms(100);    // h~              
}

// xZT[֐
void SHT31(void) {
// FxANbNXgb`

    unsigned int i;

// R}hM    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR);      // X[uIDw
    i2c_send_byte(0x24);            // R}h(MSB) = 0x24 : NbNXgb`
    i2c_send_byte(0x0B);            // R}h(LSB) = 0x0B : x   
    i2c_stop();                     // I2CXgbvRfBVs     

    __delay_ms(5);                  // ҂ (x:m~i 4.5 msec)

// xf[^ǂݏo    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR + 1);  // X[uID + 1(ǂݍݗv)
    for (i=0; i<6; i++)             // f[^荞
    {
        if (i == 5)
            data[5] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊO͎MACKԂ   
    }

    i2c_stop();             // I2CXgbvRfBVs     

    Conv();                 // xlϊ֐Ăяo
}

// xlϊ֐
void Conv(void) {
// xZFT = -45 + 175 * St / (2^16-1)    
// x16bit(MSB+LSB)2i10iɕϊ
    St = (data[0] << 8) | data[1];          // x16bit(MSB+LSB) 
    Temp = St * 175 / 65535 - 45;           // 2^16-1 = 65535
    
// xZFRH = 100 * Srh / (2^16-1)
// x16bit(MSB+LSB)2i10iɕϊ
    Srh = (data[3] << 8) | data[4];          // x16bit(MSB+LSB)
    Humi = Srh * 100 / 65535;                //         
    
// CRC͏Ȃ()    
}

// RTC֐
void RTC8564_INIT(void) {

// eWX^ݒ    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(RTC8564_ADDR);    // X[uIDw

    i2c_send_byte(0x00);            // 擪AhXw(ȉAhX̓I[gCNg)

    i2c_send_byte(0);               // AhX(0x00):Rg[WX^ 1 ݒ
    i2c_send_byte(0);               // AhX(0x01):Rg[WX^ 2 ݒ
    i2c_send_byte(0);               // AhX(0x02):vJE^ b     
    i2c_send_byte(0);               // AhX(0x03):vJE^          
    i2c_send_byte(0);               // AhX(0x04):vJE^      
    i2c_send_byte(0);               // AhX(0x05):J_[JE^    
    i2c_send_byte(0);               // AhX(0x06):J_[JE^ j     
    i2c_send_byte(0);               // AhX(0x07):J_[JE^         
    i2c_send_byte(0);               // AhX(0x08):J_[JE^ N     
    i2c_send_byte(0x80);            // AhX(0x09):A[   (AErbg=1) 
    i2c_send_byte(0x80);            // AhX(0x0A):A[   (AErbg=1)    
    i2c_send_byte(0x80);            // AhX(0x0B):A[   (AErbg=1)   
    i2c_send_byte(0x80);            // AhX(0x0C):A[ j  (AErbg=1)     
    i2c_send_byte(0x83);            // AhX(0x0D):CLKOUT= 1 Hz AEgvbgݒ (0b10000011)
    i2c_send_byte(0);               // AhX(0x0E):^C}荞ݒ~ (TFrbg=0)        
    i2c_send_byte(0);               // AhX(0x0F):^C} ݒ    
    
    i2c_stop();                     // I2CXgbvRfBVs         
}

// uU[֐
void Buzzer(void) {
    unsigned int i;                // 

    for(i=0; i<60; i++) {
        Buz = 1;
        __delay_ms(700);        // uU[ON        

        Buz = 0;
        __delay_ms(300);        // uU[OFF      
    }
}

/*
  End of File
*/