/**
   EXT_INT Generated Driver File
 
   @Company
     Microchip Technology Inc.
 
   @File Name
     ext_int.c
 
   @Summary
     This is the generated driver implementation file for the EXT_INT driver using PIC10 / PIC12 / PIC16 / PIC18 MCUs
 
   @Description
     This source file provides implementations for driver APIs for EXT_INT.
     Generation Information :
         Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.76
         Device            :  PIC16F18326
         Driver Version    :  1.11
     The generated drivers are tested against the following:
         Compiler          :  XC8 2.00
         MPLAB             :  MPLAB X 5.10
 */ 

 /**
   Section: Includes
 */
#include <xc.h>
#include "ext_int.h"

// ϐ錾
unsigned long Sec,Min,Hour;             // b,,
void (*INT_InterruptHandler)(void);

void INT_ISR(void)
{
    EXT_INT_InterruptFlagClear();

    Sec++;                          // bJEgAbv     
    
    if (Sec >= 60) {    
        Sec = 0;                    // 60bSecZbg    
        Min++;                      // JEgAbv

        if (Min >= 60) {
            Min = 0;                // 60MinŃZbg
            Hour++;                 // JEgAbv

            if (Hour >= 24)           
                Hour = 0;           // 24ԂHourZbg
        }        
    }
    
    // Callback function gets called everytime this ISR executes
    INT_CallBack();    
}


void INT_CallBack(void)
{
    // Add your custom callback code here
    if(INT_InterruptHandler)
    {
        INT_InterruptHandler();
    }
}

void INT_SetInterruptHandler(void (* InterruptHandler)(void)){
    INT_InterruptHandler = InterruptHandler;
}

void INT_DefaultInterruptHandler(void){
    // add your INT interrupt custom code
    // or set custom function using INT_SetInterruptHandler()
}

void EXT_INT_Initialize(void)
{
    
    // Clear the interrupt flag
    // Set the external interrupt edge detect
    EXT_INT_InterruptFlagClear();   
    EXT_INT_risingEdgeSet();    
    // Set Default Interrupt Handler
    INT_SetInterruptHandler(INT_DefaultInterruptHandler);
    EXT_INT_InterruptEnable();      

}

